-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
M.vehIn = {}
local settings = {}
local function driveTrainCallback(data)
	gdscenarios.driveTrain = data
end
local function driveTrain()
	if be:getPlayerVehicle(0) then
		local veh = scenetree.findObjectById(be:getPlayerVehicle(0):getID())
		local command = "obj:queueGameEngineLua(string.format('gdcallback.driveTrainCallback(%s)',serialize({gear = drivetrain.gear})))"
		if veh then
			veh:queueLuaCommand(command)
		end
	end
end
local function request(vid)
	M.vehIn = gdscenarios.vehIn
	local veh = scenetree.findObjectById(vid)
	if veh then
		veh:queueLuaCommand('gdcallback.vehInCallBack(' .. serialize(M.vehIn) .. ')')
	end
end
local function getDesc()
	local map = getMissionFilename():match('levels/([%w|_|%-|%s]+)/')
	if map == gdscenarios.oldScenario.map then
		local data = gdscenarios.oldScenario
		return data
	else
		local scenario = scenario_scenarios.getScenario()
		local name = string.find(scenario.name,'Demolition Derby')
		local found = 1
		if name then
			found = 2
		end
		local data = {name=scenario.name, desc = scenario.description, map = map, found=found}
		gdscenarios.oldScenario = data
		--dump(data)
		--print('newmap')
		return data
	end
end
local function getData(selectedMap)
	local data = {}
	local level = core_levels.getSimpleList()
	--dump(levels)
	local scenario = scenario_scenarios.getScenario()
	local map = getMissionFilename():match('levels/([%w|_|%-|%s]+)/')
	if map == nil then
		map = core_levels.getLevelName(getMissionFilename())
	end
	--if scenario.scenarioName ~= 'gdcommon' then
		--if not tracks[map] then
		--This gets tracks from a custom map 
		
	local flevels = {}  --formated map names with original names in a table
	local levels = {}
	for i,v in ipairs(level) do   --go through a list of all the maps in the game
		if v == 'gdcommon' then
			table.remove(level, i)
		else
			local str = v:upper()
			str = str:gsub("[%c%p%s]", " ")
			flevels[str] = v           -- create a table with the map name in caps and equal the map name without caps.
			table.insert(levels, str)  -- build a table of all the map names in all caps 
		end
	end
	if selectedMap then 
		local mtrack = flevels[selectedMap]
		if mtrack then 
			local fp = 'levels/'..mtrack..'/scenarios/tracks.json'
			if FS:fileExists(fp) then
				local file = readJsonFile(fp)
				if file then
					data['tracks'] =  file
				end
			end
		end
	end
	
	data['levels'] = levels
	data['flevels'] = flevels
	data['map'] = map:upper():gsub("[%c%p%s]", " ")
	data['model'], data['config2'], data['group'] = scenario_gdclasses.modelName()
	return data
end
local function getParts()
	local data = {}
	data['parts'] = scenario_gdclasses.getParts()
	return data
end
local function saveObject(key,value)
	local fn = string.format('settings/derbyMenu.json')
	local file = {}
	if FS:fileExists(fn) then
		file = readJsonFile(fn)
	end
	file[key] = value
	serializeJsonToFile(fn, file, true)
end
local function saveTable(file)
	local fn = string.format('settings/derbyMenu.json')
	if file then
		serializeJsonToFile(fn, file, true)
		gdscenarios.selection(file)
	end
end
local function loadObject()
	local fn = string.format('settings/derbyMenu.json')
	if FS:fileExists(fn) then
		local file = readJsonFile(fn)
		if file then
			settings = file
			return settings
		else
			return nil
		end
	end
end
local function removeItem(key, menu)
	local fn = string.format('settings/derbyMenu.json')
	if FS:fileExists(fn) then
		local file = readJsonFile(fn)
		if file then
			if menu then
				file[menu][key] = {}
			else
				file[key] = {}
			end
		end
		serializeJsonToFile(fn, file, true)
	end
end
local function clearAll()
	local fn = string.format('settings/derbyMenu.json')
	local file = {}
	serializeJsonToFile(fn, file, true)
end

M.getDesc = getDesc
M.getData = getData
M.saveTable = saveTable
M.clearAll = clearAll
M.saveObject = saveObject
M.loadObject = loadObject
M.removeItem = removeItem
M.getParts = getParts
M.driveTrain = driveTrain
M.driveTrainCallback = driveTrainCallback
M.request = request
return M
