-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
local helper = require('scenario/scenariohelper')
M.currentHeat = 1
local vehHeat = 0
M.vehHeat = 0
local totalHeats = 0
local heatState = 'running'
local function onVehicleSpawned(vid)
	local vehicle = be:getObjectByID(vid)
	if vehicle then
		local vehName = vehicle:getField('name', '')
		scenario_scenarios.trackVehicleMovementAfterDamage(vehName, {waitTimerLimit=2})
	end
	--log('D', 'gdheats.onVehicleSpawned', 'Spawn'..vid)
	local done = false 
	if heatState == 'not running' then
		--dump(M.vehIn)
		local vehIn = gdscenarios.vehIn
		local vehInNum = #vehIn
		local heatCount = vehHeat - vehInNum
		for i,v in pairs(vehIn) do
			if v.vid == vid then
				if i == vehInNum then
					done = true
				end
				heatCount = heatCount + 1
				local bo = be:getObjectByID(vid)
				if bo then
					bo:queueLuaCommand([[
						local vehHeat = ]]..heatCount..[[
						print("Beams Save"..vehHeat)
						gdbeams.saveNodes("vehicles/heats"..vehHeat..".json",1,vehHeat)
					]])	
				end
			end
		end
	end
	if done == true then
		heatState = 'reload'
	end
end
local function saveBeams()
	--log('D', 'gdheats.saveBeams', 'Beams')
	gdscenarios.mode = 'disabled'
	local vehIn = gdscenarios.vehIn
	for _, v in pairs(vehIn) do
		local bo = be:getObjectByID(v.vid)
		if bo then
			local mode = 'stop'
			helper.queueLuaCommand(bo, 'gdai.setState({mode = "'..mode..'"})')
			vehHeat = vehHeat + 1
			local fileparts = "vehicles/heats"..vehHeat.."parts.pc" --create a parts files.
			serializeJsonToFile(fileparts, v, true)
			bo:queueLuaCommand([[
				local vehHeat = ]]..vehHeat..[[
				print("heats"..vehHeat)
				--gdbeams.saveBeams("vehicles/heats"..vehHeat..".json")
				gdbeams.saveNodes("vehicles/heats"..vehHeat..".json")
			]])
		end
	end
end
local function reloadVeh()
	be:reloadAllVehicles(0)
	--local player = 0
	--for _, v in pairs(M.vehIn) do
	--	local vehicle = be:getObjectByID(v.vid)
	--	be:reloadVehicle(player, vehicle)
	--end
	------------------------------------------------------
	--heatState = 'not running' --temp setting remove later
end
local function exportVeh()
		local vehIn = gdscenarios.vehIn
		local vehInNum = #vehIn
		local heatCount = vehHeat - vehInNum 
		for i,v in pairs(vehIn) do
			--if v.vid == vid then
				heatCount = heatCount + 1
				scenario_gdbeams.moveNodes(heatCount,v.vid)
			--end
		end
		heatState = 'reloadtest'
end
local function loadHeat(vid, k)
	local veh = be:getObjectByID(vid)
	if veh then
		print("loading beams")
		veh:queueLuaCommand('gdbeams.loadBeams("vehicles/heats'..k..'.json")')
	end
end
local function finalHeat() ---This function checks to make sure all the vehicles are loaded before trying to recover them.
	--print("finalHeat")
	local count = gdscenarios.options.opponents + 1  
	if M.vehHeat ~= 0 then
		count = M.vehHeat
	end
	local vehIn = gdscenarios.vehIn
	local vehInNum = #vehIn
	if vehInNum == count then
		if M.vehHeat ~= 0 then
			print('loading saved vehicles')
			for k,v in ipairs(vehIn) do	
				loadHeat(v.vid, k)
			end
		end
		heatState = 'running'
	end
end
local msgTimer = 6
local function reloadHeat(dt)
	if msgTimer == 6 then
		core_vehicles.removeAll()
	end
	if msgTimer > 0 then
		local msg 
		if M.vehHeat ~= 0 then
			msg = 'Loading Feature... Please Wait'
		else
			msg = 'Loading Next Heat... Please Wait'
		end
		msgTimer = msgTimer - dt
		helper.flashUiMessage(msg, 5)
	else
		msgTimer = 6
		scenario_gdsetup.resetTimer() 
		gdscenarios.startScenario()  
		--print("startheat")
		heatState = 'reloadheat'
	end
end
local function runHeats(dt)
	local heat = gdscenarios.options.heat
	if heat == true then
		--print('heatstate'..heatState)
		if heatState == 'next' then
			saveBeams()
			heatState = 'restart'
		elseif heatState == 'restart' then
			reloadVeh()  --this is to reload the vehicle
			heatState = 'reloadveh'
		elseif heatState == 'reloadveh' then
			gdscenarios.reset(2)
			----This needs to come after resetting the vehicles
			if M.currentHeat > totalHeats then
				M.vehHeat = vehHeat
			end
			heatState = 'reset'
		elseif heatState == 'reset' then
			reloadHeat(dt)
		elseif heatState == 'reloadheat' then
			--exportVeh()
			finalHeat()
		else
			local opponents = gdscenarios.options.opponents
			local vehInNum = #gdscenarios.vehIn	
			if M.currentHeat <= totalHeats or totalHeats == 0 then
				local opponents = opponents + 1 
				if opponents < 7 then
					totalHeats = 2
				elseif opponents >= 7 then
					totalHeats = 3 	
				end
				local oppHeats = opponents / totalHeats
				if opponents <= 3 then
					oppHeats = 2
					if opponents == 2 then
						oppHeats = 1
					end
				end
				if vehInNum <= oppHeats then
					print(oppHeats)
					print(M.currentHeat)
					print(totalHeats)
					scenario_gdstats.resetHeat(M.currentHeat)
					M.currentHeat = M.currentHeat + 1
					--print('next heat')
					heatState = 'next'
				end
			end
		end
	end
end

M.runHeats = runHeats
M.onVehicleSpawned = onVehicleSpawned
return M