local M = {}
local startTimer = false
local vehDamageData = {}
local collisions = {}
local savedID = 0
local savedDamage = {}
local stats = {} 
local vehDamageList= {}
local driverInfo = {}
local heatStats = {}
M.pathData = {}
M.post = {}
local vehInCount = nil
local raceTime = 0

local function updatePlace()
	local place = {}
	local sVehicles = scenetree.findClassObjects('BeamNGVehicle')	
	for _, vName in ipairs(sVehicles) do
		 local veh = scenetree.findObject(vName)
		if veh then
			local vid = veh:getID()
			--print(vid)
			local vd = M.pathData[vid]  --get vehicle path data
			--dump(vd)
			if vd then
				local count = 1
				--print(vName)
				--print("lcount "..vd.lap.." ccount"..vd.cpPoint.." Dist"..vd.wpdist.." end")
				local vehicleData = M.pathData
				for v,d in pairs(vehicleData) do
					if v ~= vid then
						if vd.lap < d.lap then
							count = count + 1
						end
						if vd.lap == d.lap then
							if vd.cpPoint < d.cpPoint then
								count = count + 1
							end
							if vd.cpPoint == d.cpPoint then
								if vd.wpdist > d.wpdist then
									count = count + 1
								end
							end		
						end
					end
				end	
				--print(count)
				place[vid] = {count = count, lap = vd.lap, cp = vd.cpPoint, dist = vd.wpdist}
			end
		end
	end
	return place
	
	--dump(place)
end
local function updateRaceStats(playerID)
local scenario = scenario_scenarios.getScenario()
	if scenario then
		local sVehicles = scenetree.findClassObjects('BeamNGVehicle')	
		local raceOver = false
		for _, vName in ipairs(sVehicles) do
			local veh = scenetree.findObject(vName)
			if veh then 
				local vid = veh:getID()
				if not M.pathData[vid] then
					M.pathData[vid] = {cpPoint = 0, lap = 0, wpdist = 0, target = nil}
				end
				local data = scenario_waypoints.getVehicleWaypointData(vid)
				if not data then return end
				--dump(data)
				if vid == playerID then
					--if M.pathData[vid].lap < 3 then
						local lap = 1
						if M.pathData[vid].lap ~= 0 then
							lap = M.pathData[vid].lap
						end
						guihooks.trigger('RaceLapChange', {current = lap , count = scenario.lapCount} )
					--end
					if M.pathData[vid].cpPoint < 2 then 
						guihooks.trigger('WayPoint', 'Checkpoint '..M.pathData[vid].cpPoint..' / '..tostring(#scenario.lapConfig) )
					end
				end
				local pos = veh:getPosition()
				if data.nextWps[1] then 
					local node = data.nextWps[1].cpName
					if node and scenario then 
						local wp = scenario.nodes[node]
						if wp then
							local wpPos = wp.pos
							if wpPos then
								M.pathData[vid].wpdist = wpPos:distance(pos)
								--print(M.pathData[vid].wpdist)
							end
						else
							raceOver = true
							break
						end
					end
				end
				if data.next then
					if M.pathData[vid].cpPoint ~= data.next then
						M.pathData[vid].cpPoint = data.next
					end
				else
					raceOver = true
					break
				end
				if data.lap then
					if M.pathData[vid].lap ~= (data.lap + 1) then
						M.pathData[vid].lap = data.lap + 1
					end
				else 
					raceOver = true
					break
				end
			end
		end
		return raceOver
	end
end
------------------------------------------------------------------------------
--Get the collisions for each vehicle then find out how much damage during the hit
local function objectCollisions(vid)
	driverInfo[vid].foundHit = 'none'
	local vehList = gdscenarios.vehIn
	for _, v in pairs(vehList) do
		local reward = stats[vid].reward
		if not reward[v.vid] then
			reward[v.vid] = {earn = true}
		end
		if v.vid ~= vid then
			local earnReward = reward[v.vid].earn -- can this vehicle earn a reward from the opponent
		
			if earnReward == false then	
			--local oPos = driverInfo[v.vid].lastPos
				local dPosDiff = math.abs((driverInfo[vid].damagedPos - driverInfo[vid].pos):len()) 
				if dPosDiff > 5 or driverInfo[vid].tolHit > 20 then   -- there should also be a time limit.
					stats[vid].reward[v.vid].earn = true
					--stats[o.vid].reward[vid].earn = true
					if dPosDiff > 5 then
						driverInfo[vid].foundHit = 'true reset '
					else
						driverInfo[vid].foundHit = 'true total hit'
					end
				end
					driverInfo[vid].foundHit = 'false ' ..dPosDiff
			else
				if not map.objects then return end
				local collisions = map.objects[vid].objectCollisions
				if collisions then				
					for vidHit, state in pairs(collisions) do
						if state == 1 then
							if v.vid == vidHit then
								if driverInfo[vidHit].cDamage > 0 and driverInfo[vid].momentum > 0.1 then   --if the vehicle you hit has damage then continue
									local opDiff = math.abs((driverInfo[vid].pos - driverInfo[vidHit].pos):len()) 
									driverInfo[vid].foundHit = 'true '..opDiff
									if opDiff > 10 then return end
										--update the last hit time  even if we did not make the hit?
										--local momentumTotal = driverInfo[vid].momentum + driverInfo[vidHit].momentum
									if  driverInfo[vid].momentum > driverInfo[vidHit].momentum then
										local points = stats[vid].points
										stats[vid].points =  points + 1
										stats[vid].momentum = driverInfo[vid].momentum
										stats[vid].losermomentum = driverInfo[vidHit].momentum
										local damageDone = stats[vid].damageDone
										stats[vid].damageDone = math.floor(damageDone + driverInfo[vidHit].cDamage)
										driverInfo[vid].tolHit = 0
									end
									driverInfo[vidHit].lastHitby = vid
									driverInfo[vid].damagedPos = driverInfo[vid].pos
									stats[vid].reward[vidHit].earn = false
								end
							end
						end
					end
				end
			end
		end
	end
end
local function onRaceTick(raceTickTime, raceTimer)
	local mode = gdscenarios.mode 
	if mode ~= 'disabled' then
		local vehIn = gdscenarios.vehIn
		for _,v in pairs(vehIn) do
			local veh = be:getObjectByID(v.vid)
			if veh then 
				local pos = veh:getPosition()
				if not driverInfo[v.vid] then 
					driverInfo[v.vid] = {}
					driverInfo[v.vid] = {
						lastPos = pos,
						pos = pos,
						damagedPos = pos,
						momentum = 0,
						stopTicks = 0,
						damage = 0,
						lastHitby = 0,
						--sDamage = 0,  --saved Damage
						cDamage = 0,
						tDamage = 0, 	--total Damage
						tolHit = 0, --time of last hit
						foundHit = false,
						}
				end
				local vehicleData = map.objects[v.vid]
				driverInfo[v.vid].damage = vehicleData.damage / 5000 or 0
				if driverInfo[v.vid].damage ~= driverInfo[v.vid].cDamage then
					driverInfo[v.vid].cDamage = driverInfo[v.vid].damage
					driverInfo[v.vid].tDamage = driverInfo[v.vid].damage + driverInfo[v.vid].tDamage --add the current damage with the new damage
				end
				driverInfo[v.vid].momentum = math.abs((pos - driverInfo[v.vid].lastPos):len())
				driverInfo[v.vid].pos = pos
				driverInfo[v.vid].lastPos = pos 
				
				driverInfo[v.vid].tolHit =  math.abs(raceTickTime + driverInfo[v.vid].tolHit) 
				if driverInfo[v.vid].momentum > 2.5 then 
					driverInfo[v.vid].tolHit = 0
				end
				
				if not stats[v.vid] then
					stats[v.vid]= {}
					stats[v.vid] = {
						points = 0,
						damageDone = 0,
						loserList = {},
						reward = {},
						momentum = 0,
						knockouts = {},
						losermomentum = 0,
						driverNumber = v.driverNumber,
						driverName = v.driverName,
						model = v.model,
						out = 0,
						current = 0,
						place = 1,
						lap = 0,
						cp = 0,
						dist = 0
						}
				end
			end
		end
		if not vehInCount then
			vehInCount = #vehIn
		end
	end
end
local function updateStats(playerID)
	local mode = gdscenarios.mode 
	if mode ~= 'disabled' and vehInCount  then
		local raceOver = false
		local vehIn = gdscenarios.vehIn
		for _,v in pairs(vehIn) do
			objectCollisions(v.vid)
		end
		for _,v in pairs(vehIn) do
			objectCollisions(v.vid)
		end
		local currentUserVehicle = be:getPlayerVehicle(0)
		local currentVehID = currentUserVehicle:getID()
	
		for vid,v in pairs(stats) do
			if currentVehID and vid == currentVehID then
				stats[vid].current = 1
			else
				stats[vid].current = 0
			end
			--table.insert(post, {order = stats[vid].out, number = k.driverNumber, driver = k.driverName, model = k.model, damageDone = k.damageDone, vid = vid, points = k.points, momentum = k.momentum, losermomentum = k.losermomentum, player = current, inOut = inOut, field1 =  knockouts  })
		end
		local statsData = {}
		local driverData = {} 
		if mode == 'race' then
			local place = {}
			raceOver = updateRaceStats(playerID)
			place = updatePlace()
			for vid,v in pairs(stats) do
				for vid2,v2 in pairs(place) do
					if vid == vid2 then
						table.insert(statsData, {place = v2.count, driverNumber = v.driverNumber, lap = v2.lap, cp = v2.cp - 1 , current = v.current, out = v.out})
						stats[vid].place = v2.count
						stats[vid].lap = v2.lap
						stats[vid].cp = v2.cp
					end
				end
			end
		elseif mode == 'derby' then
			for vid,v in pairs(stats) do
				local found = false
				for _,v2 in pairs(vehIn) do
					if v2.vid == vid then
						found = true 
						break
					end
				end
				if not found and v.out < 1 then	
					stats[vid].place = vehInCount 
					stats[vid].out = 1
					vehInCount = vehInCount - 1
				end
				--table.insert(driverData, {driverNumber = v.driverNumber, momentum = driverInfo[vid].momentum, damage = driverInfo[vid].damage, 
					--	cdamage = driverInfo[vid].cDamage, tDamage = driverInfo[vid].tDamage, 
					--	tolHit = driverInfo[vid].tolHit,damagedPos = driverInfo[vid].foundHit})
			
				table.insert(statsData, {driverNumber = v.driverNumber, damageDone = v.damageDone, knockouts = #v.knockouts, points = v.points , current = v.current, out = stats[vid].out})
			end
		end
		local order = {race = 'place',derby = 'driverNumber'}
		local statheaders = {race = {{desc='place',name='Place'},{desc='driverNumber',name='#'},{desc='lap',name='Lap'},{desc='cp',name='CheckPoint'}}, 
					derby = {{desc='driverNumber',name='#'},{desc='damageDone',name='Beams Damaged'},{desc='knockouts',name='KnockOuts'},{desc='points',name='Points'}}}

		local newStats = {statheaders = statheaders[mode], stats = statsData, order=order[mode]}
		guihooks.trigger('DerbyStatsUpdate', newStats)
		
		--local theaders = {race = {{desc='place',name='Place'},{desc='driverNumber',name='#'},{desc='lap',name='Lap'},{desc='cp',name='CheckPoint'}}, 
				--	derby = {{desc='driverNumber',name='#'},{desc='momentum',name='momentum'},{desc='damage',name='damage'},{desc='cdamage',name='cdamage'},
				--	{desc='tDamage',name='tDamage'},{desc='tolHit',name='tolHit'},{desc='damagedPos',name='damagedPos'}}}

		--local tStats = {theaders = theaders[mode], tstats = driverData, order=order[mode]}
		--guihooks.trigger('DerbyInfoUpdate', tStats)
		
	end
		local endheaders = {Racing = {{ desc='place', name='Place'},{desc='img', name = '  '}, {desc='driverName', name = 'Driver'},{desc='driverNumber', name = '#'},{desc='points', name = 'Points'},{desc='model', name = 'Model',filter='uppercase'},{desc='laps', name = 'Laps'}, {desc='money', name = 'Money', filter='currency'}},
				Derby = {{desc='place', name = 'Place'},{desc='img', name = '  '},{desc='driverName', name = 'Driver'},{desc='driverNumber', name = '#'},{desc='points', name = 'Points'},{desc='model', name = 'Model', filter='uppercase'},{desc='knockouts',name = 'KnockOuts'},{desc='money', name = 'Money', filter='currency'}}}
		mode = gdscenarios.options.arena.type
		M.post = {headers = endheaders[mode], stats = stats}
	return raceOver
end
local function onVehicleSpawned(vid)
	local mode = gdscenarios.mode 
	if mode ~= 'disabled' then
		local vehicle = be:getObjectByID(vid)
		if vehicle then
			local vehName = vehicle:getField('name', '')
			scenario_scenarios.trackVehicleMovementAfterDamage(vehName, {waitTimerLimit=2})
		end
	end
end

local function resetHeat(heat)
	heatStats[heat] = stats
	driverInfo = {}
	stats = {}
	vehInCount = nil
end
local function getDriverInfo(vid)
	if not driverInfo[vid] then return end
	--dump(driverInfo[vid])
	return driverInfo[vid]
end
local function updateStopTicks(stopTicks, vid)
	if not driverInfo[vid] then return end
	driverInfo[vid].stopTicks = stopTicks
end
local function updateVehStats(vid)
	if not driverInfo[vid] then return end	
	local lastHitby = driverInfo[vid].lastHitby
	if lastHitby and lastHitby ~= 0 then
		table.insert(stats[lastHitby].knockouts, {vid})
	end
end

--Updates the waypoint and lap data for each vehicle
local function update(playerID)
	local raceOver = updateStats(playerID)	
	return raceOver
end
local function onScenarioRestarted()
	M.pathData = {}
	driverInfo = {}
	stats = {}
end

M.updateStopTicks = updateStopTicks
M.onScenarioRestarted = onScenarioRestarted
M.update = update
M.updateVehStats = updateVehStats
M.getDriverInfo = getDriverInfo
M.onRaceTick = onRaceTick
M.resetHeat = resetHeat
M.onObjectCollision = onObjectCollision
M.onVehicleSpawned = onVehicleSpawned
return M