-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
--local removePartsFile = {} --Table of parts to remove
local startData = {}
M.vehInSaved = {}
local vehInSaved = {}
local driverList = {
		name = {"The Big Buffoon","Mayhem Mike","Gentle Bud","Sir NoMercy","Rawhide Billie","Cushion Charlie","Mr. Gumby","Ms. Gumby","Monster","Collision Carbonara","Motor Man Jackson","Erwin the Eliminator","Softcore James","Morning Hollywood","Crash Test Tommy","Hurricane Houston","MrBeast","PewDiePie","Jacksepticeye","Markiplier","DanTDM","TheWillyrex","rezendeevil","VanossGaming","JuegaGerman","Fernanfloo","ElRubiusOMG","The Game Theorists","LazarBeam","GameGrumps","H2ODelirious","CaptainSparklez","AngryJoeShow","CinnamonToastKen","Daithi De Nogla","Gappa"},
		number = {"01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37"}
		}
local helper = require('scenario/scenariohelper')

local function addDriverInfo(unpause)
	local driverNumbers = {}
	local driverNames = {}
	--Compare old vehicle list with M.vehIn list to see what change
	for _,v in ipairs(vehInSaved) do
		if v.driverName ~= nil then
			driverNames[v.driverName] = v.driverName
		end
		if v.driverNumber ~= 0 then
			driverNumbers[v.driverNumber] = v.driverNumber
		end
	end
	local dNu
	local dNa
	local dL = driverList
	local function getRandomName()
		if not dL.number[1] then
			local count = 99
			for i = 38, count do
				table.insert(dL.name, {'dRiVeR'..i})
				table.insert(dL.number, {i})
			end
			print('gdvehicles line 46 ran out of names')
		end
		dNa = dL.name[tableChooseRandomKey(dL.name)]
		for k,name in pairs(dL.name) do
			if name == dNa then
				dNu = dL.number[k]
				table.remove(dL.name,k)
				table.remove(dL.number,k)
			end
		end
	end
	for _,v in pairs(driverNames) do
		for k,name in pairs(dL.name) do
			if v == name then
				table.remove(dL.name,k)
				table.remove(dL.number,k)
			end
		end
	end		
	local playerName
	--Get Steam player name 
	if Steam and Steam.isWorking and Steam.accountLoggedIn then
		playerName = Steam.playerName
		--print("steam username: " .. Steam.playerName)
	end
	gdscenarios.vehIn = vehInSaved
	--fill in the M.vehIn table with the random playerName and Number.
	local playerID = gdscenarios.setPlayer(unpause)
	local driver, number
	local currentHeat = scenario_gdheats.currentHeat
	for k,v in ipairs(vehInSaved) do
		if not v.driverName then
			if v.vid == playerID and currentHeat == 1 then
				if not playerName then
					getRandomName()
					driver = dNa
					number = dNu
				else
					driver = playerName or 'Player'
					number = '00'
				end
			else
				getRandomName()
				driver = dNa
				number = dNu
			end
		else
			driver = v.driverName
			number = v.driverNumber
		end
		if not driver or not number then
			driver = 'No Driver'
			number = k
		end
		gdscenarios.vehIn[k].driverName = driver
		gdscenarios.vehIn[k].driverNumber = number	
	end
	scenario_gdletters.setSignText()
	dump(gdscenarios.vehIn)
	--dump(driverList.number)
end
local function getPosRot(i)
	local arena = gdscenarios.options.arena.name
	if not startData[arena] then
		local map = getMissionFilename():match('levels/([%w|_|%-|%s]+)/')
		local fn = string.format('levels/'..map..'/prefabs/StartPos.json')
		local file = {}
		if FS:fileExists(fn) then
			startData = readJsonFile(fn)
		else
			startData = {}
		end
	end
	local data = startData[arena]
		if not data then 
			if i == 1 then 
				local pos = gdscenarios.startPos.pos
				local rot = gdscenarios.startPos.rot
				if not pos then
					local defaultSpawnPoint = setSpawnpoint.loadDefaultSpawnpoint()
					if defaultSpawnPoint then
						local spawnPoint = scenetree.findObject(defaultSpawnPoint)
						if spawnPoint then
							pos, rot = vec3(spawnPoint:getPosition()), quat(spawnPoint:getRotation()) * quat(0,0,1,0)
						end
					end
				end
				gdscenarios.startPos = {pos = pos, rot = rot}
				return  pos, rot 
			else
				local rot = gdscenarios.startPos.rot--quat(0, 0, 0, 0)
				local dir = vec3(0, -1, 0)
				local pos = vec3(0,0,0)
				
				local playerVehicleID = be:getPlayerVehicleID(0)
				for k, v in pairs(map.objects) do
					if k == playerVehicleID then
						dir = v.dirVec:normalized()
						--rot = quatFromDir(dir)
					end
				end
				local k = i - 1
				local playerVehicle = be:getObject(k)
				local offset = vec3(-dir.y, dir.x, 0)
				pos = vec3(playerVehicle:getPosition()) + offset * 5
				return pos , rot
			end
		end	
		local pos = {}
		local rot = {}
		for j,t in pairs(data) do
			j = tonumber(j)
			if j == i then
				pos = t.pos
				rot = t.rot
				rot = AngAxisF(rot.x, rot.y, rot.z, (rot.w * 3.1459) / 180.0 ):toQuatF()
				return pos, rot
			end
		end
end
local function loadExtensions(unpause)
	vehInSaved = {}
	local vehIn = gdscenarios.vehIn
	local vehHeat = scenario_gdheats.vehHeat
	if vehHeat and vehHeat > 0 and unpause ~= 2 then
		unpause = 3
	end
	local count = be:getObjectCount()
	for i = 1, count do
		local veh = be:getObject(i-1)
		if veh then
			local vid
			vid = veh:getID()
			if vid then
				if unpause ~= 2 then
					local pos, rot = getPosRot(i)
					veh:setPositionRotation(pos.x, pos.y, pos.z, rot.x, rot.y, rot.z, rot.w)
				end
				if unpause == 3 then
					table.insert(vehInSaved, {vid = vid, driverNumber = gdscenarios.vehIn[i].driverNumber, driverName = gdscenarios.vehIn[i].driverName, model = gdscenarios.vehIn[i].model, pcs = gdscenarios.vehIn[i].pcs })
				else
					local found = false
					if vehIn[i] then
						for _, v in ipairs(vehIn) do
							if v.vid == vid then
								found = true
								table.insert(vehInSaved, {vid = v.vid, driverNumber = v.driverNumber, driverName = v.driverName, model = v.model, pcs = v.pcs })
								break
							end
						end
					end
					if not found then 
						local model = veh:getField('JBeam','0')
						local pcs = veh:getField('partConfig', '0')
						table.insert(vehInSaved, {vid = vid, driverNumber = 0, driverName = nil, model = model, pcs = pcs})
						log('D', 'scenario_gdvehicles', 'vehicle was not in vehIn Table.  This is a new vehicle added ')
					end
				end
				helper.queueLuaCommand(veh, 'extensions.load("gdmain")')
			else
				log('D', 'scenario_gdvehicles', 'loadExtensions vehicleid error')
			end
		else
			log('D', 'scenario_gdvehicles', 'loadExtensions vehicle error')
		end
	end
	addDriverInfo(unpause)
end
-----------------------------------------------------------------------------
--Gets the Model and Parts Config and saves them to a table for each vehicle that will spawn.
---------------------------------------------------------------------------------
local function getConfig(veh)
	local vehHeat = scenario_gdheats.vehHeat
	local model
	local pcs
	if vehHeat and vehHeat > 0 then
		local filename =  "vehicles/heats"..veh.."parts.pc"
		local save = jsonReadFile(filename)
		if not save then
			log("E", "save", "unable to get heats file")
			return
		end
		model = save.model
		pcs = save.pcs --fileparts
		table.insert(gdscenarios.vehIn, {vid = 0, driverNumber = save.driverNumber, driverName = save.driverName, model = model, pcs = pcs})
	else 
		model, pcs = scenario_gdclasses.loadClass()
		table.insert(gdscenarios.vehIn, {vid = 0, driverNumber = 0, driverName = nil, model = model, pcs = pcs})
	end
	return model, pcs
end
-------------------------------------------------------------------------------------
--CREATES THE VEHICLES FOR THE SCENARIO  
-------------------------------------------------------------------------------------
local function createVehicles()	
	local count =  gdscenarios.options.opponents + 1
	local vehHeat = scenario_gdheats.vehHeat
	if vehHeat and vehHeat > 0 then
		count = vehHeat
	end
	gdscenarios.vehIn = {}
	for i=1,count do
		--model is the vehicle type, and pcs is the parts Configuration
		local model, pcs = getConfig(i)
		--local color = string.format("%0.2f %0.2f %0.2f %0.2f", vehicle.color.x, vehicle.color.y, vehicle.color.z, vehicle.color.w)
		local options = {config = pcs}--, pos = position}
		core_vehicles.spawnNewVehicle(model, options)
	end
	loadExtensions(1)
end
local function onScenarioRestarted()
	M.vehInSaved = {}
end

M.onScenarioRestarted = onScenarioRestarted
M.loadExtensions = loadExtensions
M.loadPosition = loadPosition
M.createVehicles = createVehicles
M.getPosRot = getPosRot

return M